<?

# ----------------------------------
# Server Booking 1.1
# ----------------------------------
# (c) 2001 Philipp Vallant
# E-Mail: shredderx@hotmail.com
# ICQ: 72670692
# http://php-abc.com/scripts/booking
# ----------------------------------
# All rights reserved
# See license.txt for information
# ----------------------------------

# Hinweis:
# --------
# Fr Fehler die auf eigenwillige Vernderungen des Quelltexts zurckzufhren sind,
# leistet der Author keinerlei Support



// Start Quelltext

include("config.inc.php");

$tage = array(
	0 => "Sonntag",
	1 => "Montag",
	2 => "Dienstag",
	3 => "Mittwoch",
	4 => "Donnerstag",
	5 => "Freitag",
	6 => "Samstag"
);

?>

<html>
<head>
<title>Server Booking 1.1</title>
<style type="text/css">
td, input, select, p { font-family:Verdana; font-size:10pt }
td { background-color:#FFFFFF }
td.rahmen { border-style:solid; border-width:1px; border-color:#000000 }
td.rahmen_top { border-style:solid; border-width:1px; border-color:#000000; color:#000099 }
td.rahmen_bottom { border-style:solid; border-width:1px; border-color:#000000; background-color:#F0F0F0; text-align:center }
a:link { font-family:Verdana; font-size:10pt; color:#000099 }
a:visited { font-family:Verdana; font-size:10pt; color:#000099 }
a:active { font-family:Verdana; font-size:10pt; color:#000099 }
a:hover { font-family:Verdana; font-size:10pt; color:#FF7700 }
a.bottom:link { font-family:Verdana; font-size:10pt; color:#000099; text-decoration:none }
a.bottom:visited { font-family:Verdana; font-size:10pt; color:#000099; text-decoration:none }
a.bottom:active { font-family:Verdana; font-size:10pt; color:#000099; text-decoration:none }
a.bottom:hover { font-family:Verdana; font-size:10pt; color:#FF7700; text-decoration:none }
</style>
</head>
<body>

<?

function error($msg) { // Error anzeigen

?>

</center>
<p><b>Es ist folgender Fehler aufgetreten:</b><br><?=$msg?></p>
<br><input type="button" value="Zurck" onClick="javascript:history.back()">
</body>
</html>

<?

die();

}

$con = mysql_connect($mysql[host], $mysql[user], $mysql[pwd]) or error("Aufbauen der MySQL-Verbindung fehlgeschlagen!<br><br><b>My-SQL Error:</b> ".mysql_error());
       mysql_select_db($mysql[db], $con) or error("Auswhlen der MySQL-Datenbank fehlgeschlagen!<br><br><b>My-SQL Error:</b> ".mysql_error());

switch($act) {

default: // Standard Einstellung, bersicht ber Server Buchungen

if(!$datum) $datum = date("d.m.Y"); // Wenn Datum nicht gesetzt, dann heutiges Datum nehmen
$datum2 = explode(".",$datum);

$maxdat1 = date("Ymd", mktime(0,0,0, date("m"), date("d")+14, date("Y"))); // Maximales Datum im Format 1 generieren
$maxdat2 = date("d.m.Y", mktime(0,0,0, date("m"), date("d")+14, date("Y"))); // Maximales Datum im Format 2 generieren
$aktdat = date("Ymd", mktime(0,0,0, $datum2[1], $datum2[0], $datum2[2])); // Vorhandenes Datum vom Format 2 auf Format 1 konvertieren

if($maxdat1 < $aktdat) error("Das eingegebene Datum liegt zu weit in der Zukunft (maximal: heutiges Datum + 14)"); // Wenn vorhanenes Datum grer als maximales Datum dann Error

$mindat = date("Ymd");
if($mindat > $aktdat) error("Das eingegebene Datum ist bereits vorbei"); // Wenn vorhandenes Datum kleiner als minimales (heutiges) Datum dann Error

$wday = date("w", mktime(0,0,0, $datum2[1], $datum2[0], $datum2[2])); // Wochentag als Zahl ermitteln (vom gegebenen Datum)

$wday = $tage[$wday]; // Wochentag-Zahl in ausgeschriebenen Wochentag umwandeln

$vtag = date("d.m.Y", mktime(0,0,0, $datum2[1], $datum2[0]-1, $datum2[2])); // Vortag ermitteln
$ntag = date("d.m.Y", mktime(0,0,0, $datum2[1], $datum2[0]+1, $datum2[2])); // Nchsten Tag ermitteln

?>

<br>

<script language="JavaScript">
function chg() {
url = '<?=$PHP_SELF?>?datum=' + document.forms[0].datum.value;
window.location.href = url;
}
</script>

<form>
<table width="750" border="0" cellspacing="0" cellpadding="0" align="center">
<tr>
<td width="100%" style="background-color:#000000">
<table width="100%" border="0" cellspacing="1" cellpadding="0">
<tr><td height="18" align="center" style="background-color:#F0F0F0">Server Booking 1.1</td></tr>
<tr>
<td align="center">
<br>

<p><b><?=$wday.", ".$datum?></b></p>
<table width="420" border="0" cellspacing="0" cellpadding="0">
<tr>

<?

if($datum != date("d.m.Y")) { // Wenn gegebenes Datum ist nicht heutiger Tag, dann Link "vorheriger Tag" einbleden
	echo "<td width=\"140\"><a href=\"".$PHP_SELF."?datum=$vtag\">&lt;&lt; Vorheriger Tag</a></td>";
} else { // Sonst keinen Link erzeugen
	echo "<td width=\"140\">&lt;&lt; Vorheriger Tag</td>";
}

?>

<td width="140" align="center"><select name="datum" size="1" onchange="chg()">

<? for($i = 0; $i <= 14; $i++) { $dat = date("d.m.Y", mktime(0,0,0, date("m"),date("d")+$i,date("Y"))); echo "<option value=\"$dat\""; if($dat == $datum) echo " selected"; echo ">$dat</option>"; } // Optionsgruppe generieren (heutiges datum + 14), wenn generiertes Datum gleich gegebenes Datum dann "selected" aktivieren ?>

</select></td>

<?

if($datum != $maxdat2) { // Wenn gegebenes Datum ungleich maximales Datum, dann Link einblenden
	echo "<td width=\"140\" align=\"right\"><a href=\"".$PHP_SELF."?datum=$ntag\">Nchster Tag &gt;&gt;</a></td>";
} else { // Sonst keinen Link erzeugen
	echo "<td width=\"140\" align=\"right\">Nchster Tag &gt;&gt;</td>";
}

?>

</tr>
</table></form>
<br>

<iframe src="<?=$PHP_SELF."?act=tabelview&datum=".$datum?>" width="700" height="73" frameborder="0" marginwidth="0" marginheight="0">Ihr Browser untersttzt keine I-Frames! Optimale Darstellung: IE v.5 or higher</iframe>
<br><br><br>
<iframe src="<?=$PHP_SELF."?act=detailstd"?>" name="detail" width="420" height="245" marginwidth="5" marginheight="5" frameborder="0" style="border-style:solid; border-width:1px">Ihr Browser untersttzt keine I-Frames! Optimale Darstellung: IE v.5 or higher</iframe><br><br>

</td></tr>
<tr><td height="18" align="center" style="background-color:#F0F0F0">
<p><font color="#000099"><a href="<?=$PHP_SELF."?act=add&datum=".$datum?>" target="detail" class="bottom">Server Buchen</a> | <a href="warplaner.php" target="detail" class="bottom">Zum Warplaner</a> | <a href="admin/c_admin.php" target="_new" class="bottom">Clan Administration</a> | <a href="admin/s_admin.php" target="_new" class="bottom">Script Administration</a> | <a href="<?=$PHP_SELF."?act=kontakt"?>" target="detail" class="bottom">Kontakt</a></font></p>

</td></tr></table>
</td></tr></table>
<br>
<center><p>Server Booking 1.1 | &copy; 2001 <a href="mailto:shredderx@hotmail.com">Philipp Vallant</a> | <a href="http://php-abc.com/scripts/booking" target="_new">php-abc.com/scripts/booking</a></p></center>

<?

break;

case 'tabelview': // Tabelle mit Buchungen anzeigen

?>

<table border="0" cellspacing="2" cellpadding="3">
<tr>

<?
$hours = 0;
$min = "00";
for($i=0; $i<48; $i++) { // Tabellenberschrift mit den Uhrzeiten von 0 - 24 generieren, in 30 min Abstnden
if($hours < 10) { $hour = "0".$hours; } else { $hour = $hours; }
echo "<td colspan=\"2\" class=\"rahmen_top\">$hour:$min</td>";
if($min == "00") { $min = "30"; } else { $min = "00"; $hours = $hours + 1; }
}
?>

</tr>
<tr>
<td class="rahmen">&nbsp;</td>

<?

$datum = explode(".",$datum);
$datum = $datum[2]."-".$datum[1]."-".$datum[0]; // Datum ins Format 'Y-m-d' umwandeln

$hours = 0;
$min = "00";
for($i=0; $i<47; $i++) { // Uhrzeiten von 0 - 24 in 30 min Abstnden fr die Datenbank Auslesung generieren
if($hours < 10) { $hour = "0".$hours; } else { $hour = $hours; }
$time = $hour.$min;


$result = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE startt <= '$time' AND endt > '$time' AND day = '$datum'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());

if(mysql_num_rows($result) == 1) { // Wenn Server zu diesem Zeitpunkt gebucht, dann Link generieren, und Clan anzeigen

	$tblbookings = mysql_fetch_array($result, MYSQL_ASSOC);
	$result2 = mysql_query("SELECT * FROM ".$mysql[prefix]."clans WHERE id = '$tblbookings[clan]'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
	$tblclans = mysql_fetch_array($result2, MYSQL_ASSOC);

	echo "<td class=\"rahmen_bottom\" colspan=\"2\"><a href=\"".$PHP_SELF."?act=detail&id=$tblbookings[id]\" target=\"detail\">$tblclans[clan]</a></td>";

} else { // Sonst als Frei kennzeichnen
	echo "<td colspan=\"2\" class=\"rahmen\">-Frei-</td>";
}

if($min == "00") { $min = "30"; } else { $min = "00"; $hours = $hours + 1; }

}

?>

<td class="rahmen">&nbsp;</td>
</tr>
<tr>

<?
for($i=0; $i<96; $i++) {
echo "<td width=\"17\"></td>";
}
?>

</tr>
</table>
</td></tr></table>

<?

break;

case 'detailstd': // Wird am Anfang im Detailbereich eigeblendet

?>
<center><p>-Detailansicht-</p></center><br>
<?

break;

case 'detail': // Details einblenden

?>
<center><p>-Detailansicht-</p><br>
<?

$result = mysql_query("SELECT id, clan, title, date_format(day, '%d.%m.%Y') as day, startt, endt, name, date_format(booktime, '%d.%m.%Y, %H:%i:%s') as booktime FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());

$tblbookings = mysql_fetch_array($result, MYSQL_ASSOC);

$day2 = explode(".",$tblbookings[day]);
$wday = date("w", mktime(0,0,0, $day2[1], $day2[0], $day2[2])); // Wochentag als Zahl ermitteln (vom Book Datum)
$wday = $tage[$wday]; // Wochentag-Zahl in ausgeschriebenen Wochentag umwandeln

if($tblbookings[startt] == 0) { // Wenn Zeit ist 00:00 Uhr (Wert: 0) dann daraus 4-stellige Zahl machen
	$tblbookings[startt] = "000".$tblbookings[startt];
} else {
	if($tblbookings[startt] == 30) { // Wenn Zeit ist 00:30 (Wert: 30) dann daraus 4-stellige Zahl machen
		$tblbookings[startt] = "00".$tblbookings[startt];
	} else {
		if($tblbookings[startt] < 1000) { // Wenn Zeit ist kleiner als 10:00 Uhr (Wert <1000) dann daraus 4-stellige Zahl machen
			$tblbookings[startt] = "0".$tblbookings[startt];
		}
	}
}

if($tblbookings[endt] == 0) { // Wenn Zeit ist 00:00 Uhr (Wert: 0) dann daraus 4-stellige Zahl machen
	$tblbookings[endt] = "000".$tblbookings[endt];
} else {
	if($tblbookings[endt] == 30) { // Wenn Zeit ist 00:30 (Wert: 30) dann daraus 4-stellige Zahl machen
		$tblbookings[endt] = "00".$tblbookings[endt];
	} else {
		if($tblbookings[endt] < 1000) { // Wenn Zeit ist kleiner als 10:00 Uhr (Wert <1000) dann daraus 4-stellige Zahl machen
			$tblbookings[endt] = "0".$tblbookings[endt];
		}
	}
}

$startt1 = substr($tblbookings[startt],0,2); // erste 2 stellen nehmen und in $start1 speichern
$startt2 = substr($tblbookings[startt],2,4); // letze 2 stellen nehmen und in $start2 speichern
$startt = $startt1.":".$startt2; // Zeit aus den Variablen generieren

$endt1 = substr($tblbookings[endt],0,2); // erste 2 stellen nehmen und in $start1 speichern
$endt2 = substr($tblbookings[endt],2,4); // letze 2 stellen nehmen und in $start2 speichern
$endt = $endt1.":".$endt2; // Zeit aus den Variablen generieren

$result2 = mysql_query("SELECT * FROM ".$mysql[prefix]."clans WHERE id = '$tblbookings[clan]'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
$tblclans = mysql_fetch_array($result2, MYSQL_ASSOC);

?>

<table width="380" border="0" cellspacing="0" cellpadding="0">
<tr><td>Clan:</td><td><?=$tblclans[clan]?></td></tr>
<tr><td>Booking Titel:</td><td><?=$tblbookings[title]?></td></tr>
<tr><td>Datum:</td><td><?=$wday.", ".$tblbookings[day]?></td></tr>
<tr><td>Zeit:</td><td>Start: <?=$startt?> Uhr, Ende: <?=$endt?> Uhr</td></tr>
<tr><td>Gebucht von:</td><td><?=$tblbookings[name]?></td></tr>
<tr><td>Buchungszeit:</td><td><?=$tblbookings[booktime]?></td></tr>
<tr><td align="center" colspan="2"><br><br><a href="<?=$PHP_SELF."?act=edit&id=".$tblbookings[id]?>">editieren</a> | <a href="<?=$PHP_SELF."?act=delete&id=".$tblbookings[id]?>">lschen</a></td></tr>
<tr><td align="center" colspan="2"><br><a href="<?=$PHP_SELF."?act=email&id=".$tblbookings[id]?>">Daten per Mail zusenden</a></td></tr>
</table>

</center>

<?

break;

case 'add': // Buchungs Formular

?>
<center><p>-Detailansicht-</p><br>
<?

$result = mysql_query("SELECT * FROM ".$mysql[prefix]."clans") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());

if(mysql_num_rows($result) == 0) { echo "<p>Derzeit noch keine Clans eingetragen!<br><br>ber den Punkt <a href=\"admin/s_admin.php\" target=\"_new\">Script Administration</a> knnen sie neue Clans hinzufgen</p></body></html>"; die(); }

?>

<form action="<?=$PHP_SELF."?act=book"?>" method="post">

<table width="380" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>Clan:</td>
<td><select name="clan" size="1">

<?

while($tblclans = mysql_fetch_array($result, MYSQL_ASSOC)) {
	echo "<option value=\"$tblclans[id]\">$tblclans[clan]</option>";
}

?>

</select>
</td>
</tr>
<tr>
<td>Clan Passwort:</td>
<td><input type="password" name="passwort" size="10" maxlength="8"></td>
</tr>
<tr>
<td>Booking Titel:</td>
<td><input type="text" name="title" size="20" maxlength="30"></td>
</tr>
<tr>
<td>Datum:</td>
<td><select name="datum" size="1">

<? for($i = 0; $i <= 14; $i++) { $dat = date("d.m.Y", mktime(0,0,0, date("m"),date("d")+$i,date("Y"))); echo "<option"; if($dat == $datum) echo " selected"; echo ">$dat</option>"; } // Optionsgruppe generieren (heutiges datum + 14), wenn generiertes Datum gleich gegebenes Datum dann "selected" aktivieren ?>

</select></td>
</tr>
<tr>
<td>Zeit:</td>
<td>Start: <select name="startt" size="1">

<?
$hours = 0;
$min = "00";
for($i=0; $i<48; $i++) { // Optionsgruppe mit den Uhrzeiten von 0 - 24 generieren, in 30 min Abstnden
if($hours < 10) { $hour = "0".$hours; } else { $hour = $hours; }
echo "<option>$hour:$min</option>";
if($min == "00") { $min = "30"; } else { $min = "00"; $hours = $hours + 1; }
}
?>

</select>
 Ende: <select name="endt" size="1">

<?
$hours = 0;
$min = "00";
for($i=0; $i<48; $i++) { // Optionsgruppe mit den Uhrzeiten von 0 - 24 generieren, in 30 min Abstnden
if($hours < 10) { $hour = "0".$hours; } else { $hour = $hours; }
echo "<option>$hour:$min</option>";
if($min == "00") { $min = "30"; } else { $min = "00"; $hours = $hours + 1; }
}
?>

</select>

</td>
</tr>
<tr>
<td>Dein Nickname:</td>
<td><input type="text" name="name" size="20" maxlength="20"></td>
</tr>
<tr><td><br><input type="submit" value="Book"></td></tr>
</table>

</form>
</center>

<?

break;

case 'book': // Buchung durchfhren

?>
<center><p>-Detailansicht-</p><br>
<?

if(!$clan) error("Bitte geben sie einen Clan ein!"); // Wenn Clan nicht eingegeben dann Error
if(!$passwort) error("Bitte geben sie das Clan Passwort ein!"); // Wenn Passwort nicht eingegeben dann Error
if(!$title) error("Bitte geben sie den Booking Titel ein z.B. \"EF-Training\""); // Wenn Titel nicht eingegeben dann Error
if(!$name) error("Bitte geben sie ihren Nickname ein z.B. \"pmp://headshot\""); // Wenn Booker Name nicht eingegeben dann Error

$result = mysql_query("SELECT * FROM ".$mysql[prefix]."clans WHERE id = '$clan'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());

if(mysql_num_rows($result) == 0) error("Ungltiger Clan!");
$tblclans = mysql_fetch_array($result, MYSQL_ASSOC);

if($tblclans[passwort] != $passwort) error("Das eingegebene Passwort ist nicht korrekt!"); // Wenn Passwort nicht korrekt dann Error

if($startt == $endt) error("Die Startzeit und die Endzeit sind identisch, verarsche jemand anderen ;-)");

$datum = explode(".",$datum);
$datum2 = $datum[2]."-".$datum[1]."-".$datum[0]; // Datum ins Format 'Y-m-d' umwandeln
$datum = implode(".",$datum);

$startt = explode(":",$startt);
$endt = explode(":",$endt);
$startt = $startt[0].$startt[1]; // Startzeit ins Format 'Hi' umwandeln
$endt = $endt[0].$endt[1]; // Endzeit ins Format 'Hi' umwandeln

if($startt > $endt) error("Die Startzeit ist grer als die Endzeit, mglicherweise haben sie ber Mitternacht gebucht. Dies untersttzt das Script leider nicht, da ich nicht checke wie das funzt ;-)"); // Wenn Startzeit grer als Endzeit dann Error

$jetzt = date("YmdHis"); // Datum und Zeit generieren

$test1 = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE startt <= '$startt' AND endt > '$startt' AND day = '$datum2'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Wenn eingegebene Startzeit in bereits gebuchtem Zeitraum liegt dann Error
$test2 = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE startt < '$endt' AND endt >= '$endt' AND day = '$datum2'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Wenn eingegebene Endzeit in bereits gebuchtem Zeitraum liegt dann Error
$test3 = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE startt >= '$startt' AND endt <= '$endt' AND day = '$datum2'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Wenn Startzeit und Endzeit auerhalb gebuchtem Zeitraum, jedoch ber gebuchten Zeitraum erstrecken dann Error

if(mysql_num_rows($test1) >= 1 || mysql_num_rows($test2) >= 1 || mysql_num_rows($test3) >=1) error("Zu dieser Zeit ist der Server bereits gebucht! Whlen sie einen anderen Zeitraum!"); // Wenn eine oder mehrere der 3 Bedingungen nicht erfllt, dann Error

mysql_query("INSERT INTO ".$mysql[prefix]."bookings (clan, title, day, startt, endt, name, booktime) VALUES ('$clan', '$title', '$datum2', '$startt', '$endt', '$name', '$jetzt')") or error("Fehler beim durchfhren der Buchung! Die Werte konnten nicht in die Datenbank eingetragen werden.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Daten in My-Sql Tabelle schreiben

?>

<p>Die Buchung wurde erfolgreich durchgefhrt!</p>
<a href="<?=$PHP_SELF."?datum=".$datum?>" target="_parent">Aktualisieren</a>
</center>

<?

break;

case 'edit': // Buchung editieren

?>
<center><p>-Detailansicht-</p><br>
<?

$result = mysql_query("SELECT id, clan, title, date_format(day, '%d.%m.%Y') as day, startt, endt, name FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
if(mysql_num_rows($result) == 0) error("Ungltige ID!");

$tblbookings = mysql_fetch_array($result, MYSQL_ASSOC);

if($tblbookings[startt] == 0) { // Wenn Zeit ist 00:00 Uhr (Wert: 0) dann daraus 4-stellige Zahl machen
	$tblbookings[startt] = "000".$tblbookings[startt];
} else {
	if($tblbookings[startt] == 30) { // Wenn Zeit ist 00:30 (Wert: 30) dann daraus 4-stellige Zahl machen
		$tblbookings[startt] = "00".$tblbookings[startt];
	} else {
		if($tblbookings[startt] < 1000) { // Wenn Zeit ist kleiner als 10:00 Uhr (Wert <1000) dann daraus 4-stellige Zahl machen
			$tblbookings[startt] = "0".$tblbookings[startt];
		}
	}
}

if($tblbookings[endt] == 0) { // Wenn Zeit ist 00:00 Uhr (Wert: 0) dann daraus 4-stellige Zahl machen
	$tblbookings[endt] = "000".$tblbookings[endt];
} else {
	if($tblbookings[endt] == 30) { // Wenn Zeit ist 00:30 (Wert: 30) dann daraus 4-stellige Zahl machen
		$tblbookings[endt] = "00".$tblbookings[endt];
	} else {
		if($tblbookings[endt] < 1000) { // Wenn Zeit ist kleiner als 10:00 Uhr (Wert <1000) dann daraus 4-stellige Zahl machen
			$tblbookings[endt] = "0".$tblbookings[endt];
		}
	}
}

$startt1 = substr($tblbookings[startt],0,2); // erste 2 stellen nehmen und in $start1 speichern
$startt2 = substr($tblbookings[startt],2,4); // letze 2 stellen nehmen und in $start2 speichern
$startt = $startt1.":".$startt2; // Zeit aus den Variablen generieren

$endt1 = substr($tblbookings[endt],0,2); // erste 2 stellen nehmen und in $start1 speichern
$endt2 = substr($tblbookings[endt],2,4); // letze 2 stellen nehmen und in $start2 speichern
$endt = $endt1.":".$endt2; // Zeit aus den Variablen generieren

$result2 = mysql_query("SELECT * FROM ".$mysql[prefix]."clans WHERE id = '$tblbookings[clan]'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
$tblclans = mysql_fetch_array($result2, MYSQL_ASSOC);

?>

<form action="<?=$PHP_SELF."?act=doedit&id=".$id?>" method="post">

<table width="380" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>Clan:</td>
<td><?=$tblclans[clan]?></td>
</tr>
<tr>
<td>Clan Passwort:</td>
<td><input type="password" name="passwort" size="10" maxlength="8"></td>
</tr>
<tr>
<td>Booking Titel:</td>
<td><input type="text" name="title" value="<?=$tblbookings[title]?>" size="20" maxlength="30"></td>
</tr>
<tr>
<td>Datum:</td>
<td><select name="datum" size="1">

<? for($i = 0; $i <= 14; $i++) { $dat = date("d.m.Y", mktime(0,0,0, date("m"),date("d")+$i,date("Y"))); echo "<option"; if($dat == $tblbookings[day]) echo " selected"; echo ">$dat</option>"; } // Optionsgruppe generieren (heutiges Datum + 14), wenn Datum gleich Buchungsdatum dann "selected" einblenden ?>

</select></td>
</tr>
<tr>
<td>Zeit:</td>
<td>Start: <select name="startt" size="1">

<?
$hours = 0;
$min = "00";
for($i=0; $i<48; $i++) { // Optionsgruppe mit den Uhrzeiten von 0 - 24 generieren, in 30 min Abstnden
if($hours < 10) { $hour = "0".$hours; } else { $hour = $hours; }
$time = $hour.":".$min;
echo "<option"; if($time == $startt) echo " selected"; echo ">$time</option>";
if($min == "00") { $min = "30"; } else { $min = "00"; $hours = $hours + 1; }
}
?>

</select>
 Ende: <select name="endt" size="1">

<?
$hours = 0;
$min = "00";
for($i=0; $i<48; $i++) { // Optionsgruppe mit den Uhrzeiten von 0 - 24 generieren, in 30 min Abstnden
if($hours < 10) { $hour = "0".$hours; } else { $hour = $hours; }
$time = $hour.":".$min;
echo "<option"; if($time == $endt) echo " selected"; echo ">$time</option>";
if($min == "00") { $min = "30"; } else { $min = "00"; $hours = $hours + 1; }
}
?>

</select>

</td>
</tr>
<tr>
<td>Dein Nickname:</td>
<td><input type="text" name="name" value="<?=$tblbookings[name]?>" size="20" maxlength="20"></td>
</tr>
<tr><td><br><input type="submit" value="Edit"></td></tr>
</table>

</form>
</center>

<?

break;

case 'doedit': // Editieren durchfhren

?>
<center><p>-Detailansicht-</p><br>
<?

if(!$passwort) error("Bitte geben sie das Clan Passwort ein!"); // Wenn Passwort nicht eingegeben dann Error
if(!$title) error("Bitte geben sie den Booking Titel ein z.B. \"EF-Training\""); // Wenn Titel nicht eingegeben dann Error
if(!$name) error("Bitte geben sie ihren Nickname ein z.B. \"pmp://headshot\""); // Wenn Booker Name nicht eingegeben dann Error

$result = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
if(mysql_num_rows($result) == 0) error("Ungltige ID!");
$tblbookings = mysql_fetch_array($result, MYSQL_ASSOC);

$result2 = mysql_query("SELECT * FROM ".$mysql[prefix]."clans WHERE id = '$tblbookings[clan]'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
$tblclans = mysql_fetch_array($result2, MYSQL_ASSOC);

if($tblclans[passwort] != $passwort) error("Das eingegebene Passwort ist nicht korrekt!"); // Wenn Passwort nicht korrekt dann Error

if($startt == $endt) error("Die Startzeit und die Endzeit sind identisch, verarsche jemand anderen ;-)"); // Wenn Startzeit gleich Endzeit dann Error

$datum = explode(".",$datum);
$datum2 = $datum[2]."-".$datum[1]."-".$datum[0]; // Datum ins Format 'Y-m-d' umwandeln
$datum = implode(".",$datum);

$startt = explode(":",$startt);
$endt = explode(":",$endt);
$startt = $startt[0].$startt[1]; // Startzeit ins Format 'Hi' umwandeln
$endt = $endt[0].$endt[1]; // Endzeit ins Format 'Hi' umwandeln

if($startt > $endt) error("Die Startzeit ist grer als die Endzeit, mglichweise haben sie ber Mitternacht gebucht. Dies untersttzt das Script leider nicht, da ich nicht checke wie das funzt ;-)"); // Wenn Startzeit grer als Endzeit dann Error

$jetzt = date("YmdHis"); // Datum und Zeit generieren

$test1 = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE startt <= '$startt' AND endt > '$startt' AND day = '$datum2' AND id != '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Wenn eingegebene Startzeit in bereits gebuchtem Zeitraum liegt und nicht von derzeit editierter Buchung stammt dann Error
$test2 = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE startt < '$endt' AND endt >= '$endt' AND day = '$datum2' AND id != '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Wenn eingegebene Endzeit in bereits gebuchtem Zeitraum liegt und nicht von derzeit editierter Buchung stammt dann Error
$test3 = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE startt >= '$startt' AND endt <= '$endt' AND day = '$datum2' AND id != '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Wenn Startzeit und Endzeit auerhalb gebuchtem Zeitraum, jedoch ber gebuchten Zeitraum erstrecken und nicht von derzeit editierter Buchung stammen dann Error

if(mysql_num_rows($test1) >= 1 || mysql_num_rows($test2) >= 1 || mysql_num_rows($test3) >=1) error("Zu dieser Zeit ist der Server bereits gebucht! Whlen sie einen anderen Zeitraum!"); // Wenn eine oder mehrere der 3 Bedingungen nicht erfllt, dann Error

mysql_query("UPDATE ".$mysql[prefix]."bookings SET clan = '$tblbookings[clan]', title = '$title', day = '$datum2', startt = '$startt', endt = '$endt', name = '$name', booktime = '$jetzt' WHERE id = '$id'") or error("Fehler beim durchfhren der Buchung! Die Werte konnten nicht in die Datenbank eingetragen werden.<br><br><b>My-SQL Error:</b> ".mysql_error()); // Daten in My-Sql Tabelle schreiben

?>

<p>Die Buchung wurde erfolgreich editiert!</p>
<a href="<?=$PHP_SELF."?datum=".$datum?>" target="_parent">Aktualisieren</a>
</center>

<?

break;

case 'delete': // Lschen von Buchungen

$result = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
if(mysql_num_rows($result) == 0) error("Ungltige ID!");

?>
<center><p>-Detailansicht-</p><br>

<form action="<?=$PHP_SELF."?act=dodel&id=".$id?>" method="post">

<table width="380" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>Clan Passwort:</td>
<td><input type="password" name="passwort" size="10" maxlength="8"></td>
</tr>
<tr>
<td><br>Wirklich lschen?</td>
<td><br><input type="submit" value=" Ja "> <input type="button" value="Nein" onClick="javascript:history.back()"></td>
</tr>
</table>

</form>
</center>

<?

break;

case 'dodel': // lschen ausfhren

?>
<center><p>-Detailansicht-</p><br>
<?

if(!$passwort) error("Bitte geben sie das Clan Passwort ein!"); // Wenn Passwort nicht eingegeben dann Error

$result = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
if(mysql_num_rows($result) == 0) error("Ungltige ID!");
$tblbookings = mysql_fetch_array($result, MYSQL_ASSOC);

$result2 = mysql_query("SELECT * FROM ".$mysql[prefix]."clans WHERE id = '$tblbookings[clan]'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
$tblclans = mysql_fetch_array($result2, MYSQL_ASSOC);

if($tblclans[passwort] != $passwort) error("Das eingegebene Passwort ist nicht korrekt!"); // Wenn Passwort nicht korrekt dann Error

mysql_query("DELETE FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lschen der Buchung!<br><br><b>My-SQL Error:</b> ".mysql_error());

?>

<p>Die Buchung wurde erfolgreich gelscht!</p>
<a href="javascript:parent.location.reload()">Aktualisieren</a>
</center>

<?

break;

case 'email':

$result = mysql_query("SELECT * FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
if(mysql_num_rows($result) == 0) error("Ungltige ID!");

?>
<center><p>-Detailansicht-</p><br>

<form action="<?=$PHP_SELF."?act=domail&id=".$id?>" method="post">

<table width="380" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>E-Mail Adresse:</td>
<td><input type="text" name="email" value="sepp@kaaskiachla.at" size="20" onClick="this.form.email.value=''"></td>
</tr>
<tr><td><br><input type="submit" value="Send"></td></tr>
</table>

</form>
</center>

<?

break;

case 'domail':

?>
<center><p>-Detailansicht-</p><br>
<?

if(!$email) error("Bitte geben sie eine E-Mail Adresse ein!");

$result = mysql_query("SELECT id, clan, title, date_format(day, '%d.%m.%Y') as day, startt, endt, name, date_format(booktime, '%d.%m.%Y, %H:%i:%s') as booktime FROM ".$mysql[prefix]."bookings WHERE id = '$id'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
if(mysql_num_rows($result) == 0) error("Ungltige ID!");

$tblbookings = mysql_fetch_array($result, MYSQL_ASSOC);

$day2 = explode(".",$tblbookings[day]);
$wday = date("w", mktime(0,0,0, $day2[1], $day2[0], $day2[2])); // Wochentag als Zahl ermitteln (vom Book Datum)
$wday = $tage[$wday]; // Wochentag-Zahl in ausgeschriebenen Wochentag umwandeln

if($tblbookings[startt] == 0) { // Wenn Zeit ist 00:00 Uhr (Wert: 0) dann daraus 4-stellige Zahl machen
	$tblbookings[startt] = "000".$tblbookings[startt];
} else {
	if($tblbookings[startt] == 30) { // Wenn Zeit ist 00:30 (Wert: 30) dann daraus 4-stellige Zahl machen
		$tblbookings[startt] = "00".$tblbookings[startt];
	} else {
		if($tblbookings[startt] < 1000) { // Wenn Zeit ist kleiner als 10:00 Uhr (Wert <1000) dann daraus 4-stellige Zahl machen
			$tblbookings[startt] = "0".$tblbookings[startt];
		}
	}
}

if($tblbookings[endt] == 0) { // Wenn Zeit ist 00:00 Uhr (Wert: 0) dann daraus 4-stellige Zahl machen
	$tblbookings[endt] = "000".$tblbookings[endt];
} else {
	if($tblbookings[endt] == 30) { // Wenn Zeit ist 00:30 (Wert: 30) dann daraus 4-stellige Zahl machen
		$tblbookings[endt] = "00".$tblbookings[endt];
	} else {
		if($tblbookings[endt] < 1000) { // Wenn Zeit ist kleiner als 10:00 Uhr (Wert <1000) dann daraus 4-stellige Zahl machen
			$tblbookings[endt] = "0".$tblbookings[endt];
		}
	}
}

$startt1 = substr($tblbookings[startt],0,2); // erste 2 stellen nehmen und in $start1 speichern
$startt2 = substr($tblbookings[startt],2,4); // letze 2 stellen nehmen und in $start2 speichern
$startt = $startt1.":".$startt2; // Zeit aus den Variablen generieren

$endt1 = substr($tblbookings[endt],0,2); // erste 2 stellen nehmen und in $start1 speichern
$endt2 = substr($tblbookings[endt],2,4); // letze 2 stellen nehmen und in $start2 speichern
$endt = $endt1.":".$endt2; // Zeit aus den Variablen generieren

$result2 = mysql_query("SELECT * FROM ".$mysql[prefix]."clans WHERE id = '$tblbookings[clan]'") or error("Fehler beim Lesen der My-SQL Tabelle.<br><br><b>My-SQL Error:</b> ".mysql_error());
$tblclans = mysql_fetch_array($result2, MYSQL_ASSOC);

$mailtext = "Hier die von Ihnen gewnschten Daten:\n\nClan: $tblclans[clan]\nBooking Titel: $tblbookings[title]\nDatum: $wday, $tblbookings[day]\nZeit: Start: $startt Uhr, Ende: $endt Uhr\nGebucht von: $tblbookings[name]\nBuchungszeit: $tblbookings[booktime]\n\nServer Booking 1.1 by Philipp Vallant\nvisite http://php-abc.com/scripts/booking";

if(!mail($email, "Server Booking", $mailtext, "From: Info_Mailer\nReply-To: info@pmp4ever.com")) error("Fehler beim Senden der Daten, ein unbekannter Fehler ist Aufgetreten");

?>
<p>Die Daten wurden erfolgreich an <b><?=$email?></b> gesendet!<br><br>
<a href="<?=$PHP_SELF."?act=detail&id=".$id?>" target="detail">Zurck</a></p>
</center>
<?

break;

case 'kontakt':

?>
<center><p>-Detailansicht-</p><br>

<table width="380" border="0" cellspacing="0" cellpadding="0">
<tr>
<td>
<b>Server Booking 1.1</b><br><br>
&copy; 2001 Philipp Vallant feat. pmp://ShredderX<br>
E-Mail: <a href="mailto:shredderx@hotmail.com">shredderx@hotmail.com</a><br>
Messenger: shredderx@hotmail.com<br>
ICQ: <a href="http://wwp.icq.com/scripts/search.dll?to=72670692">72670692</a><br>
<a href="http://php-abc.com/scripts/booking" target="_new">http://php-abc.com/scripts/booking</a><br><br>
All rights reserved
</td>
</tr>
</table>

<?

break;

}

mysql_close($con);

?>

</body>
</html>
